Index: /trunk/sources/HeuristicLab.Problems.VehicleRouting.Views/3.3/VRPSolutionView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.VehicleRouting.Views/3.3/VRPSolutionView.Designer.cs	(revision 6446)
+++ /trunk/sources/HeuristicLab.Problems.VehicleRouting.Views/3.3/VRPSolutionView.Designer.cs	(revision 6447)
@@ -50,5 +50,5 @@
       this.valueTabPage = new System.Windows.Forms.TabPage();
       this.tourGroupBox = new System.Windows.Forms.GroupBox();
-      this.tourGridView = new System.Windows.Forms.DataGridView();
+      this.valueTextBox = new System.Windows.Forms.TextBox();
       this.tabControl.SuspendLayout();
       this.visualizationTabPage.SuspendLayout();
@@ -56,9 +56,9 @@
       this.valueTabPage.SuspendLayout();
       this.tourGroupBox.SuspendLayout();
-      ((System.ComponentModel.ISupportInitialize)(this.tourGridView)).BeginInit();
       this.SuspendLayout();
       // 
       // tabControl
       // 
+      this.tabControl.AllowDrop = true;
       this.tabControl.Controls.Add(this.visualizationTabPage);
       this.tabControl.Controls.Add(this.valueTabPage);
@@ -83,7 +83,7 @@
       // pictureBox
       // 
-      this.pictureBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.pictureBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.pictureBox.BackColor = System.Drawing.Color.White;
       this.pictureBox.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
@@ -108,5 +108,5 @@
       // tourGroupBox
       // 
-      this.tourGroupBox.Controls.Add(this.tourGridView);
+      this.tourGroupBox.Controls.Add(this.valueTextBox);
       this.tourGroupBox.Dock = System.Windows.Forms.DockStyle.Fill;
       this.tourGroupBox.Location = new System.Drawing.Point(3, 3);
@@ -117,13 +117,12 @@
       this.tourGroupBox.Text = "Tour";
       // 
-      // tourGridView
+      // valueTextBox
       // 
-      this.tourGridView.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.AutoSize;
-      this.tourGridView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.tourGridView.Location = new System.Drawing.Point(3, 16);
-      this.tourGridView.Name = "tourGridView";
-      this.tourGridView.ReadOnly = true;
-      this.tourGridView.Size = new System.Drawing.Size(403, 507);
-      this.tourGridView.TabIndex = 0;
+      this.valueTextBox.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.valueTextBox.Location = new System.Drawing.Point(3, 16);
+      this.valueTextBox.Multiline = true;
+      this.valueTextBox.Name = "valueTextBox";
+      this.valueTextBox.Size = new System.Drawing.Size(403, 507);
+      this.valueTextBox.TabIndex = 0;
       // 
       // VRPSolutionView
@@ -139,5 +138,5 @@
       this.valueTabPage.ResumeLayout(false);
       this.tourGroupBox.ResumeLayout(false);
-      ((System.ComponentModel.ISupportInitialize)(this.tourGridView)).EndInit();
+      this.tourGroupBox.PerformLayout();
       this.ResumeLayout(false);
 
@@ -151,5 +150,5 @@
     private System.Windows.Forms.TabPage valueTabPage;
     private System.Windows.Forms.GroupBox tourGroupBox;
-    private System.Windows.Forms.DataGridView tourGridView;
+    private System.Windows.Forms.TextBox valueTextBox;
 
 
Index: /trunk/sources/HeuristicLab.Problems.VehicleRouting.Views/3.3/VRPSolutionView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.VehicleRouting.Views/3.3/VRPSolutionView.cs	(revision 6446)
+++ /trunk/sources/HeuristicLab.Problems.VehicleRouting.Views/3.3/VRPSolutionView.cs	(revision 6447)
@@ -28,4 +28,5 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Problems.VehicleRouting.Encodings;
+using System.Text;
 
 namespace HeuristicLab.Problems.VehicleRouting.Views {
@@ -84,17 +85,17 @@
 
     private void UpdateTourView() {
-      tourGridView.Rows.Clear();
-      tourGridView.ColumnCount = Content.Coordinates.Rows - 1;
+      StringBuilder sb = new StringBuilder();
 
       if (Content != null && Content.Solution != null) {
         foreach (Tour tour in Content.Solution.GetTours(new ValueLookupParameter<DoubleMatrix>("DistanceMatrix", Content.DistanceMatrix))) {
-          int row = tourGridView.Rows.Add();
-          int cell = 0;
           foreach (int city in tour.Cities) {
-            tourGridView.Rows[row].Cells[cell].Value = city;
-            cell++;
+            sb.Append(city);
+            sb.Append(" ");
           }
+          sb.AppendLine();
         }
       }
+
+      valueTextBox.Text = sb.ToString();
     }
 